/* tde91d.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

int main(void)
{
    /* Builtin functions */
    double exp(double);

    /* Local variables */
    extern int de91d_c(U_fp, U_fp, int *, double *, double *, double *,
                       double *, double *, double *, float *, double *,
                       double *, int *);
    static double hmin;
    static int ierr;
    static double a, b, c__;
    extern int f_c();
    static float h__;
    static int m;
    static double p, r__[81], y[4], t1, t2, t3, y1, y2, y3, y4, dd, ff, gg;
    extern int fj_c();
    static int ih;
    static double qq, xk, xn, yn[4], eps;

    m = 4;
    xn = 0.;
    yn[0] = 1.;
    yn[1] = 1.;
    yn[2] = 1.;
    yn[3] = 1.;
    hmin = 1e-10;
    eps = .01;
    p = 100.;
    xk = 20.;
/* BCEHE TOHOO PEEH CCTEM: */
    y4 = exp(xk * -.1f);
    t1 = exp(-xk);
    y3 = t1 * -10.111111111111111 + y4 * 11.111111111111111;
    t2 = exp(xk * -1e3);
    a = -.10121232343454566;
    b = .10112122323343446;
    c__ = 1. - a - b;
    y2 = c__ * t2 + a * t1 + b * y4;
    t3 = exp(xk * -1e4);
    dd = c__ / 90.;
    ff = (a * 100. + 101.11111111111111) / 9999.;
    gg = (b * 100. - 111.11111111111111 + 1.) / 9999.9;
    qq = 1. - dd - ff - gg;
    y1 = qq * t3 + dd * t2 + ff * t1 + gg * y4;

    printf("\n %22.14e %22.14e ", y1, y2);
    printf("\n %22.14e %22.14e \n", y3, y4);
    ih = 0;
L10:
    ++ih;
    h__ = .01f;
    de91d_c((U_fp)f_c, (U_fp)fj_c, &m, &xn, yn, &xk, &hmin, &eps, &p, &h__, y,
            r__, &ierr);

    printf("\n %22.14e \n", eps);
    printf("\n %22.14e %22.14e ", y[0], y[1]);
    printf("\n %22.14e %22.14e \n", y[2], y[3]);
    printf("\n %22.14e \n", h__);
    eps *= .1;
    if (ih < 3) {
        goto L10;
    }
    return 0;
} /* main */

int f_c(double *x, double *y, double *dy, int *m)
{
    /* Parameter adjustments */
    --dy;
    --y;

    /* Function Body */
    dy[1] = y[1] * -1e4 + y[2] * 100. - y[3] * 10. + y[4];
    dy[2] = y[2] * -1e3 + y[3] * 10. - y[4] * 10.;
    dy[3] = -y[3] + y[4] * 10.;
    dy[4] = y[4] * -.1;
    return 0;
} /* f_c */

int fj_c(double *x, double *y, double *df, int *m)
{
#define df_ref(a_1,a_2) df[(a_2)*4 + a_1]

    /* Parameter adjustments */
    df -= 5;
    --y;

    /* Function Body */
    df_ref(1, 1) = -1e4;
    df_ref(1, 2) = 100.;
    df_ref(1, 3) = -10.;
    df_ref(1, 4) = 1.;
    df_ref(2, 1) = 0.;
    df_ref(2, 2) = -1e3;
    df_ref(2, 3) = 10.;
    df_ref(2, 4) = -10.;
    df_ref(3, 1) = 0.;
    df_ref(3, 2) = 0.;
    df_ref(3, 3) = -1.;
    df_ref(3, 4) = 10.;
    df_ref(4, 1) = 0.;
    df_ref(4, 2) = 0.;
    df_ref(4, 3) = 0.;
    df_ref(4, 4) = -.1;
    return 0;
} /* fj_c */

#undef df_ref
